Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TableLinesViewerComparator.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TableLinesViewerComparator.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TableLinesViewerComparator.java	(revision 3628)
@@ -30,14 +30,14 @@
 // The class TableResult or MatrixResult should define a method sort(int columnIndex), abstract or not
 public class TableLinesViewerComparator extends ViewerComparator {
 
-	
+
 	public static final int DESCENDING = 1;
-	
+
 	/**
 	 * Last column index.
 	 */
 	protected int lastColumnIndex = 0;
-	
+
 	/**
 	 * Current direction.
 	 */
@@ -47,12 +47,12 @@
 	 * Collator to use for Strings comparison.
 	 */
 	protected Collator collator;
-	
+
 	/**
 	 * If true all the viewer columns will be packed after a sort.
 	 */
 	protected boolean autoPackColumns;
-	
+
 	/**
 	 * 
 	 * @param collator
@@ -60,7 +60,7 @@
 	public TableLinesViewerComparator(Collator collator) {
 		this(collator, true);
 	}
-	
+
 	/**
 	 * 
 	 * @param collator
@@ -72,22 +72,26 @@
 		this.lastColumnIndex = 0;
 		this.direction = 0;
 	}
-	
 
+
 	@Override
 	public int compare(Viewer viewer, Object e1, Object e2) {
-		
+
 		int result = 0;
 
 		Object cell1 = e1;
 		Object cell2 = e2;
 
-		
-		if(e1 instanceof List)	{
+		if (e1 instanceof List)	{
 			cell1 = ((List)e1).get(this.lastColumnIndex);
 			cell2 = ((List)e2).get(this.lastColumnIndex);
 		}
-		
+
+		if (e1 instanceof Object[])	{
+			cell1 = ((Object[])e1)[this.lastColumnIndex];
+			cell2 = ((Object[])e2)[this.lastColumnIndex];
+		}
+
 		if (Integer.class.isInstance(cell1))	{
 			result = ((Integer)cell1).compareTo(((Integer)cell2));
 		}
@@ -109,8 +113,8 @@
 		else if (Date.class.isInstance(cell1))	{
 			result = ((Date)cell1).compareTo(((Date)cell2));
 		}
-		
-		
+
+
 		// reverse if needed
 		if (this.direction == DESCENDING) {
 			result = -result;
@@ -118,7 +122,7 @@
 		return result;
 	}
 
-	
+
 	/**
 	 * 
 	 * @return
@@ -131,7 +135,7 @@
 	 * 
 	 * @param column
 	 */
-	public void setColumn(int column) {
+	protected void setColumn(int column) {
 		if (column == this.lastColumnIndex) {
 			// same column as last, toggle sorting direction
 			this.direction = 1 - this.direction;
@@ -154,18 +158,23 @@
 		column.addSelectionListener(new SelectionAdapter() {
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				
-				setColumn(index);
-				
-				viewer.getTable().setSortDirection(getDirection());
-				viewer.getTable().setSortColumn(column);
-				
-				if (autoPackColumns)	{
-					TXMEditor.packColumns(viewer);
+
+				if ((e.stateMask & SWT.SHIFT) != 0) {
+					
+
+				} else {
+					setColumn(index);
+
+					viewer.getTable().setSortDirection(getDirection());
+					viewer.getTable().setSortColumn(column);
+
+					if (autoPackColumns)	{
+						TXMEditor.packColumns(viewer);
+					}
+					else	{
+						viewer.refresh();
+					}
 				}
-				else	{
-					viewer.refresh();
-				}
 			}
 		});
 	}
@@ -178,14 +187,14 @@
 	 */
 	// FIXME: SJ: not used at this time but could be useful?
 	public void addSelectionAdapters(final TableViewer viewer, int startingColIndex, int endingColIndex) {
-		
+
 		Table table = viewer.getTable();
-		
+
 		for (int i = startingColIndex; i < endingColIndex; i++) {
 			this.addSelectionAdapter(viewer, table.getColumn(i), i);
 		}
 	}
-	
+
 	/**
 	 * Adds some selection adapters to all columns that have a non empty header label.
 	 * @param viewer
@@ -199,14 +208,14 @@
 			}
 		}
 	}
-	
 
+
 	/**
 	 * @param direction the direction to set
 	 */
 	public void setDirection(int direction) {
 		this.direction = direction;
 	}
-	
 
+
 }
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/splashHandlers/TXMSplashHandler.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/splashHandlers/TXMSplashHandler.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/splashHandlers/TXMSplashHandler.java	(revision 3628)
@@ -90,50 +90,50 @@
 		
 		
 		
-		// here you could check some condition on which decoration to show
-		
-		version = "TXM "+ApplicationWorkbenchAdvisor.getTXMVersion(); //$NON-NLS-1$
-		
-		String build_date =  ApplicationWorkbenchAdvisor.getBuildDate(ApplicationWorkbenchAdvisor.getBuildVersion());
-		
-		String txm_date = ApplicationWorkbenchAdvisor.getUpdateDate();
-		
-		level = ApplicationWorkbenchAdvisor.getVersionLevel().toUpperCase();
-		
-		greenTXM = new Color(splash.getDisplay(), 109,139,0);
-		redTXM = new Color(splash.getDisplay(), 255,0,0);
-		font = new Font(splash.getDisplay(), "Arial", 17, SWT.BOLD); //$NON-NLS-1$
-		
-		if (txm_date.equals(build_date)) {
-			infos = build_date;
-		}
-		else {
-			infos = "update " + txm_date + " - build " + build_date; //$NON-NLS-1$ //$NON-NLS-2$
-		}
-		
-		if ("STABLE".equals(level)) { //$NON-NLS-1$
-			level = null;
-		}
-		
-		getContent().addPaintListener(new PaintListener() {
-			
-			@Override
-			public void paintControl(PaintEvent e) {
-				e.gc.setFont(font);
-				e.gc.setForeground(greenTXM);
-				Point textSize2 = e.gc.textExtent(version);
-				e.gc.drawString(version, (int) (316 - textSize2.x - (BORDER*1.5)), 230, true);
-				
-				Point textSize = e.gc.textExtent(infos);
-				e.gc.drawString(infos, (int) (316 - textSize.x - (BORDER*1.5)), 233 + textSize2.y, true);
-				
-				if (level != null) {
-					e.gc.setForeground(redTXM);
-					textSize = e.gc.textExtent(level);
-					e.gc.drawString(level, (int) (316 - textSize.x - (BORDER*1.5)), 2*BORDER, true);
-				}
-			}
-		});
+//		// here you could check some condition on which decoration to show
+//		
+//		version = "TXM "+ApplicationWorkbenchAdvisor.getTXMVersion(); //$NON-NLS-1$
+//		
+//		String build_date =  ApplicationWorkbenchAdvisor.getBuildDate(ApplicationWorkbenchAdvisor.getBuildVersion());
+//		
+//		String txm_date = ApplicationWorkbenchAdvisor.getUpdateDate();
+//		
+//		level = ApplicationWorkbenchAdvisor.getVersionLevel().toUpperCase();
+//		
+//		greenTXM = new Color(splash.getDisplay(), 109,139,0);
+//		redTXM = new Color(splash.getDisplay(), 255,0,0);
+//		font = new Font(splash.getDisplay(), "Arial", 17, SWT.BOLD); //$NON-NLS-1$
+//		
+//		if (txm_date.equals(build_date)) {
+//			infos = build_date;
+//		}
+//		else {
+//			infos = "update " + txm_date + " - build " + build_date; //$NON-NLS-1$ //$NON-NLS-2$
+//		}
+//		
+//		if ("STABLE".equals(level)) { //$NON-NLS-1$
+//			level = null;
+//		}
+//		
+//		getContent().addPaintListener(new PaintListener() {
+//			
+//			@Override
+//			public void paintControl(PaintEvent e) {
+//				e.gc.setFont(font);
+//				e.gc.setForeground(greenTXM);
+//				Point textSize2 = e.gc.textExtent(version);
+//				e.gc.drawString(version, (int) (316 - textSize2.x - (BORDER*1.5)), 230, true);
+//				
+//				Point textSize = e.gc.textExtent(infos);
+//				e.gc.drawString(infos, (int) (316 - textSize.x - (BORDER*1.5)), 233 + textSize2.y, true);
+//				
+//				if (level != null) {
+//					e.gc.setForeground(redTXM);
+//					textSize = e.gc.textExtent(level);
+//					e.gc.drawString(level, (int) (316 - textSize.x - (BORDER*1.5)), 2*BORDER, true);
+//				}
+//			}
+//		});
 	}
 	
 	@Override
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchAdvisor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchAdvisor.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchAdvisor.java	(revision 3628)
@@ -1,30 +1,3 @@
-// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
-// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
-// Lyon 2, University of Franche-Comté, University of Nice
-// Sophia Antipolis, University of Paris 3.
-//
-// The TXM platform is free software: you can redistribute it
-// and/or modify it under the terms of the GNU General Public
-// License as published by the Free Software Foundation,
-// either version 2 of the License, or (at your option) any
-// later version.
-//
-// The TXM platform is distributed in the hope that it will be
-// useful, but WITHOUT ANY WARRANTY; without even the implied
-// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-// PURPOSE. See the GNU General Public License for more
-// details.
-//
-// You should have received a copy of the GNU General
-// Public License along with the TXM platform. If not, see
-// http://www.gnu.org/licenses.
-//
-//
-//
-// $LastChangedDate:$
-// $LastChangedRevision:$
-// $LastChangedBy:$
-//
 package org.txm.rcp;
 
 import java.io.File;
@@ -57,7 +30,6 @@
 import org.eclipse.jface.operation.IRunnableWithProgress;
 import org.eclipse.jface.preference.IPreferenceNode;
 import org.eclipse.jface.preference.PreferenceManager;
-import org.eclipse.jface.resource.JFaceResources;
 import org.eclipse.jface.util.Util;
 import org.eclipse.jface.viewers.ArrayContentProvider;
 import org.eclipse.jface.viewers.LabelProvider;
@@ -69,11 +41,9 @@
 import org.eclipse.swt.widgets.Event;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.IEditorReference;
-import org.eclipse.ui.IViewPart;
 import org.eclipse.ui.IWorkbench;
 import org.eclipse.ui.IWorkbenchPage;
 import org.eclipse.ui.IWorkbenchPreferenceConstants;
-import org.eclipse.ui.IWorkbenchWindow;
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.application.IWorkbenchConfigurer;
 import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
@@ -89,7 +59,6 @@
 import org.eclipse.ui.internal.IPreferenceConstants;
 import org.eclipse.ui.internal.WorkbenchPlugin;
 import org.eclipse.ui.internal.dialogs.WorkbenchPreferenceNode;
-import org.eclipse.ui.statushandlers.StatusManager;
 import org.osgi.framework.Bundle;
 import org.osgi.framework.BundleContext;
 import org.osgi.framework.FrameworkUtil;
@@ -101,6 +70,7 @@
 import org.txm.core.results.TXMResult;
 import org.txm.objects.Project;
 import org.txm.rcp.commands.OpenWelcomePage;
+import org.txm.rcp.commands.RecoverCorporaFromInstalls;
 import org.txm.rcp.commands.RestartTXM;
 import org.txm.rcp.commands.workspace.LoadBinaryCorporaDirectory;
 import org.txm.rcp.handlers.scripts.ExecuteGroovyScript;
@@ -115,11 +85,8 @@
 import org.txm.utils.io.IOUtils;
 import org.txm.utils.logger.Log;
 
-/**
- * Manages the opening and closing of TXM
- */
 public class ApplicationWorkbenchAdvisor extends WorkbenchAdvisor {
-	
+
 	private boolean installPreferenceRestored;
 	
 	private IOConsoleOutputStream stream;
@@ -137,8 +104,9 @@
 	
 	@Override
 	public IAdaptable getDefaultPageInput() {
-		org.eclipse.core.resources.IWorkspace workspace = org.eclipse.core.resources.ResourcesPlugin.getWorkspace();
-		return workspace.getRoot();
+		// MD test 02022023
+		//org.eclipse.core.resources.IWorkspace workspace = org.eclipse.core.resources.ResourcesPlugin.getWorkspace();
+		return null;
 	}
 	
 	/**
@@ -236,10 +204,11 @@
 						}
 						
 						// CREATE THE CLOSE CONTROL FILE
-						File lockFile = new File(ResourcesPlugin.getWorkspace().getRoot().getLocation().toFile().getAbsolutePath(), "txm_was_not_closed_correctly.lock");
+						String rootPath = Platform.getInstanceLocation().getURL().toURI().getPath();
+						File lockFile = new File(rootPath, "txm_was_not_closed_correctly.lock");
 						if (lockFile.exists()) { // the close control file was not deleted //$NON-NLS-1$
 							
-							File checkupResultFile = new File(ResourcesPlugin.getWorkspace().getRoot().getLocation().toFile().getAbsolutePath(), "startup_diagnostic_"+Toolbox.dateformat.format(new Date())+".txt"); //$NON-NLS-1$ //$NON-NLS-2$
+							File checkupResultFile = new File(rootPath, "startup_diagnostic_"+Toolbox.dateformat.format(new Date())+".txt"); //$NON-NLS-1$ //$NON-NLS-2$
 							this.syncExec(new Runnable() {
 								@Override
 								public void run() {
@@ -821,7 +790,9 @@
 			try {
 				Log.info(NLS.bind(TXMUIMessages.installPathColonP0, Toolbox.getInstallDirectory()));
 				
-				txmhomedir = ResourcesPlugin.getWorkspace().getRoot().getLocation().toFile().getCanonicalFile();
+				//MD test 02022023
+				//txmhomedir = ResourcesPlugin.getWorkspace().getRoot().getLocation().toFile().getCanonicalFile();
+				txmhomedir = Platform.getLocation().toFile().getCanonicalFile();
 				txmhomedir.mkdirs(); // creates the directory if needed
 				
 				txmhomedir.mkdirs(); // creates the directory if needed
@@ -847,10 +818,6 @@
 				return false;
 			}
 			
-			
-			
-			
-			
 		} // end if
 		
 		return true;
@@ -860,181 +827,18 @@
 	 * Install the sample corpora and previous TXM version corpora in TXM corpora directory
 	 * 
 	 * @param monitor
+	 * @throws IOException 
+	 * @throws IllegalStateException 
 	 */
-	private void installCorporaDirectory(IProgressMonitor monitor) {
+	private void installCorporaDirectory(IProgressMonitor monitor) throws IllegalStateException, IOException {
 		// if (org.eclipse.core.runtime.Platform.inDevelopmentMode()) {
 		// System.out.println("DEV MODE: no corpus restored!");
 		// return; // dev mode
 		// }
 		monitor.setTaskName(TXMUIMessages.restoringCorpora);
-		String installdirpath = Toolbox.getInstallDirectory();
-		File sampleCorporaDirectory = new File(installdirpath, "samples"); //$NON-NLS-1$
 		
-		if (txmhomedir == null) {
-			txmhomedir = new File(Toolbox.getTxmHomePath().trim());
-		}
-		corporaDir = new File(txmhomedir, "corpora"); //$NON-NLS-1$
+		RecoverCorporaFromInstalls.restore(true);
 		
-		String previousVersions[] = { "0.8.1", "0.8.0", "0.7.9" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-		String previousVersionLabels[] = new String[previousVersions.length];
-		File previousVersionCorporaDirectories[] = new File[previousVersions.length];
-		
-		for (int i = 0; i < previousVersions.length; i++) {
-			String v = previousVersions[i];
-			
-			previousVersionLabels[i] = TXMUIMessages.bind(TXMUIMessages.corporaOfPreviousTXMP0, v);
-			
-			File dir = new File(System.getProperty("user.home"), "TXM-" + v + "/corpora"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-			if ("0.7.9".equals(v)) { //$NON-NLS-1$
-				dir = new File(System.getProperty("user.home"), "TXM/corpora"); //$NON-NLS-1$ //$NON-NLS-2$
-			}
-			previousVersionCorporaDirectories[i] = dir;
-		}
-		
-		Version v = Activator.getDefault().getBundle().getVersion();
-		String vv = v.getMajor() + "." + v.getMinor() + "." + v.getMicro(); //$NON-NLS-1$ //$NON-NLS-2$ $NON-NLS-2$
-		String SAMPLES = "1. " + TXMUIMessages.bind(TXMUIMessages.sampleCorporaOfCurrentTXMP0, vv); //$NON-NLS-1$
-		int n = 2;
-		String vCURRENT = "2. " + TXMUIMessages.bind(TXMUIMessages.corporaOfPreviousTXMP0, vv); //$NON-NLS-1$
-		
-		
-		final ArrayList<Object> selectedCorporaDirs = new ArrayList<>();
-		selectedCorporaDirs.add(SAMPLES);
-		
-		if (corporaDir.exists() && corporaDir.listFiles(IOUtils.HIDDENFILE_FILTER).length > 0) {
-			selectedCorporaDirs.add(vCURRENT);
-			n++;
-		}
-		
-		for (int i = 0; i < previousVersions.length; i++) {
-			if (previousVersionCorporaDirectories[i].exists()
-					&& previousVersionCorporaDirectories[i].listFiles(IOUtils.HIDDENFILE_FILTER).length > 0) {
-				selectedCorporaDirs.add("" + (n++) + ". " + previousVersionLabels[i]); //$NON-NLS-1$ //$NON-NLS-2$
-			}
-		}
-		
-		String OTHER = "" + (n++) + ". " + TXMUIMessages.selectAnotherTXMCorporaToRestore; //$NON-NLS-1$ //$NON-NLS-2$
-		selectedCorporaDirs.add(OTHER);
-		
-		final ArrayList<Object> initialSelectionCorporaDirs = new ArrayList<>();
-		initialSelectionCorporaDirs.add(SAMPLES);
-		initialSelectionCorporaDirs.add(vCURRENT);
-		
-		Display.getDefault().syncExec(new Runnable() {
-			
-			@Override
-			public void run() {
-				Display display = Display.getDefault();
-				Shell shell = display.getActiveShell();
-				ListSelectionDialog dialog = new ListSelectionDialog(shell, selectedCorporaDirs,
-						new ArrayContentProvider(), new LabelProvider(), TXMUIMessages.corporaWillBeRestoredInTheFollowingOrderCorporaAlreadyRestoredWillNotBeReplaced);
-				dialog.setTitle(TXMUIMessages.selectThecorporaSetsToRestore);
-				dialog.setInitialElementSelections(initialSelectionCorporaDirs);
-				if (dialog.open() == ListSelectionDialog.OK) {
-					selectedCorporaDirs.clear();
-					List<Object> selection = Arrays.asList(dialog.getResult());
-					selectedCorporaDirs.addAll(selection);
-				}
-				else {
-					selectedCorporaDirs.clear();
-				}
-			}
-		});
-		
-		// move the previous TXM 0.8.2 corpora
-		File backupDir = new File(corporaDir.getAbsolutePath() + "-previous"); //$NON-NLS-1$
-		if (corporaDir.exists()) {
-			backupDir.mkdirs();
-			for (File dir : corporaDir.listFiles(IOUtils.HIDDENFILE_FILTER)) {
-				File bdir = new File(backupDir, dir.getName());
-				DeleteDir.deleteDirectory(bdir);
-				dir.renameTo(bdir);
-			}
-		}
-		
-		corporaDir.mkdir();
-		
-		// load TXM-0.8.2 sample corpora (from the install directory)
-		if (selectedCorporaDirs.contains(SAMPLES) && sampleCorporaDirectory.exists()) {
-			
-			Log.info(TXMUIMessages.installingSampleCorpus);
-			
-			JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(sampleCorporaDirectory, false, true, false);
-			try {
-				job.join();
-			}
-			catch (InterruptedException e) {
-				// TODO Auto-generated catch block
-				e.printStackTrace();
-			}
-		}
-		
-		// TXM-CURRENT previous installation corpora
-		if (selectedCorporaDirs.contains(vCURRENT) && backupDir.listFiles(IOUtils.HIDDENFILE_FILTER).length > 0) { // not a new install, restore corpus from the corpora-previous directory
-			Log.info(NLS.bind(TXMUIMessages.installingPreviousCorpusFromP0, vv, corporaDir));
-			JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(backupDir, false, false, true);
-			try {
-				job.join();
-			}
-			catch (InterruptedException e) {
-				e.printStackTrace();
-			}
-		}
-		
-		for (int i = 0; i < previousVersions.length; i++) {
-			if (selectedCorporaDirs.contains(previousVersionLabels[i])) {
-				
-				Log.info(NLS.bind(TXMUIMessages.installingPreviousCorpusFromP0, previousVersions[i], previousVersionCorporaDirectories[i]));
-				
-				JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(previousVersionCorporaDirectories[i], false, false, true);
-				try {
-					job.join();
-				}
-				catch (InterruptedException e) {
-					e.printStackTrace();
-				}
-			}
-		}
-		
-		// recovery from an other corpora directory to select by the user
-		if (selectedCorporaDirs.contains(OTHER)) { // new installation (empty corpora directory)
-			final HashMap<String, String> bindings = new HashMap<>();
-			Display.getDefault().syncExec(new Runnable() {
-				
-				@Override
-				public void run() {
-					Display display = Display.getDefault();
-					Shell shell = display.getActiveShell();
-					DirectoryDialog dialog = new DirectoryDialog(shell);
-					String path = dialog.open();
-					if (path == null) return;
-					
-					bindings.put("path", path); //$NON-NLS-1$
-				}
-			});
-			if (bindings.containsKey("path")) { //$NON-NLS-1$
-				File dir = new File(bindings.get("path")); //$NON-NLS-1$
-				if (!dir.equals(corporaDir)) {
-					Log.info(NLS.bind(TXMUIMessages.restoringCorporaFromTheP0Directory, dir));
-					JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(dir, true, true, true);
-					try {
-						job.join();
-					}
-					catch (InterruptedException e) {
-						e.printStackTrace();
-					}
-				}
-			}
-		}
-		
-		Display.getDefault().syncExec(new Runnable() {
-			
-			@Override
-			public void run() {
-				RestartTXM.reloadViews();
-			}
-		});
-		
 		try {
 			Display.getDefault().syncExec(new Runnable() {
 				
